
#include "app.h"

/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "APP_QSPI_FLASH.h"
#include "AI8051U_GPIO.h"
#include "AI8051U_NVIC.h"
#include "AI8051U_QSPI.h"
#include "AI8051U_UART.h"
#include "AI8051U_Switch.h"
#include "AI8051U_NVIC.h"
#include "AI8051U_DMA.h"
#include "qspi.h"
#include "w25qxx.h"
/*************    ˵    **************

ͨӲQSPIӿ1ߡ2ߡ4ģʽ֧QSPIЭFlashждԡ

(P3.0,P3.1)ӡʽĬ: 115200,8,N,1.

ʱ, ѡʱ 40MHz (ļ"config.h"޸).

******************************************/


#define IMG_SIZE            (320UL * 240 * 2)
//#define DMA_AMT_LEN         (51200UL)
#define DMA_AMT_LEN         (20UL)
#define DMA_CNT             (IMG_SIZE / DMA_AMT_LEN)
//========================================================================
//                               س    
//========================================================================

//sbit    QSPI_CS     =   P4^0;
SBIT(QSPI_CS,0xc0/*P4*/,0);
//sbit    QSPI_IO0    =   P4^1;
SBIT(QSPI_IO0,0xc0/*P4*/,1);
//sbit    QSPI_IO1    =   P4^2;
SBIT(QSPI_IO1,0xc0/*P4*/,2);
//sbit    QSPI_SCK    =   P4^3;
SBIT(QSPI_SCK,0xc0/*P4*/,3);
//sbit    QSPI_IO2    =   P5^2;
SBIT(QSPI_IO2,0xc8/*P5*/,2);
//sbit    QSPI_IO3    =   P5^3;
SBIT(QSPI_IO3,0xc8/*P5*/,3);

//========================================================================
//                               ر
//========================================================================

int i;
BYTE xdata buf[1024];

//========================================================================
//                               غ
//========================================================================

#define SIZE            30

#define INIT_BUF()      for (i=0; i<SIZE; i++) buf[i] = 0;
#define SET_BUF()       for (i=0; i<SIZE; i++) buf[i] = (BYTE)(i + 0x00);
#define PRINT_BUF()     for (i=0; i<SIZE; i++)                              \
                        {                                                   \
                            printf("%02x ", (u16)buf[i]);                       \
                            if ((i % 32) == 31)                             \
                                printf("\n                            ");   \
                        }                                                   \
                        printf("\n");

//========================================================================
//                            ⲿͱ
//========================================================================

extern u8 Key1_cnt;
extern u8 Key2_cnt;
extern bit Key1_Flag;
extern bit Key2_Flag;


typedef struct
{
    char strSign[4];
    DWORD dwCount;
    DWORD dwAddress[62];
} FAT;

FAT     Fat;                            //ļ
DWORD   dwOffset;                       //ͼƬݵƫƵַ
int     nIndex;                         //ͼƬ
int     nCount;                         //ͼƬװش
BOOL    fLoading;                       //װݱ־

void QSPI_DMA_Isr() interrupt DMA_QSPI_VECTOR
{
    DMA_QSPI_STA = 0x00;
    //QSPI2TFT_Next();                    //DMAһ
		DMA_QSPI_CR = 0x00;             //ֹͣQSPI_DMA
		DMA_QSPI_CFG = 0x00;
		//DMA_LCM_CR = 0x00;
		DMA_UR1T_CR = 0x00;
		DMA_P2P_CR1 = 0x00;
		fLoading = 0;
}

u8 xdata ba[1] _at_ 0;
u8 xdata bb[1] _at_ 1;
u8 xdata bc[1] _at_ 2;



//========================================================================
// : DMA_UART_init
// : ûʼ.
// : None.
// : None.
// 汾: V1.0, 2021-05-27
//========================================================================
void DMA_UART_init(void)
{
    u16 i;
    COMx_InitDefine COMx_InitStructure;         //ṹ
    DMA_UART_InitTypeDef DMA_UART_InitStructure;//ṹ
    InitStruct(COMx_InitStructure);
		InitStruct(DMA_UART_InitStructure);
    
    DMA_UART_InitStructure.DMA_TX_Length = DMA_AMT_LEN;             //DMAֽ (0~65535) + 1
    //DMA_UART_InitStructure.DMA_TX_Buffer = (u16)DmaBuffer;  //ݴ洢ַ
    DMA_UART_InitStructure.DMA_RX_Length = DMA_AMT_LEN;             //DMAֽ (0~65535) + 1
    //DMA_UART_InitStructure.DMA_RX_Buffer = (u16)DmaBuffer;  //ݴ洢ַ
    DMA_UART_InitStructure.DMA_TX_Enable = ENABLE;          //DMAʹ ENABLE,DISABLE
    DMA_UART_InitStructure.DMA_RX_Enable = ENABLE;          //DMAʹ ENABLE,DISABLE
    DMA_UART_Inilize(UART1, &DMA_UART_InitStructure);       //ʼ
   
    DMA_UR1R_CLRFIFO();        // DMA FIFO
    DmaTx1Flag = 0;
    DmaRx1Flag = 0;
    
}

//========================================================================
// : QSPI_Flash_init
// : ûʼ.
// : None.
// : None.
// 汾: V1.0, 2025-02-08
//========================================================================
void QSPI_Flash_init(void)
{
    COMx_InitDefine COMx_InitStructure;     //ṹ
    QSPI_InitTypeDef QSPI_InitStructure;    //ṹ
    InitStruct(COMx_InitStructure);
    InitStruct(QSPI_InitStructure);
    P4_MODE_OUT_PP(GPIO_Pin_0 | GPIO_Pin_3);    //P4.0, P4.3 Ϊ
    P4_SPEED_HIGH(GPIO_Pin_LOW);                //P4.0~P4.3 ÿٵƽת
    P5_SPEED_HIGH(GPIO_Pin_2 | GPIO_Pin_3);     //P5.2, P5.3 ÿٵƽת
    P4_PULL_UP_ENABLE(GPIO_Pin_LOW);            //P4.0~P4.3 ʹ
    P5_PULL_UP_ENABLE(GPIO_Pin_2 | GPIO_Pin_3); //P5.2, P5.3 ʹ
    P4_BP_ENABLE(GPIO_Pin_1 | GPIO_Pin_2);      //P4.1, P4.2 ӲԶö˿ģʽ
    P5_BP_ENABLE(GPIO_Pin_2 | GPIO_Pin_3);      //P5.2, P5.3 ӲԶö˿ģʽ
    QSPI_SW(QSPI_P40_P41_P42_P52_P53_P43);      //QSPI_P14_P15_P16_P13_P12_P17,QSPI_P40_P41_P42_P52_P53_P43,QSPI_P47_P25_P26_P46_P45_P27

    P3_PULL_UP_ENABLE(GPIO_Pin_2 | GPIO_Pin_3); //P3.2 ʹ
    
    QSPI_CS = 1;
    QSPI_SCK = 1;
    QSPI_IO0 = 1;
    QSPI_IO1 = 1;
    QSPI_IO2 = 1;
    QSPI_IO3 = 1;
    
    COMx_InitStructure.UART_Mode      = UART_8bit_BRTx; //ģʽ,   UART_ShiftRight,UART_8bit_BRTx,UART_9bit,UART_9bit_BRTx
    COMx_InitStructure.UART_BRT_Use   = BRT_Timer2;     //ѡʷ, BRT_Timer2 (ע: 2̶ʹBRT_Timer2, Բѡ)
    COMx_InitStructure.UART_BaudRate  = 10000000;//115200ul;       //,     110 ~ 115200
    COMx_InitStructure.UART_RxEnable  = ENABLE;         //,   ENABLE  DISABLE
    UART_Configuration(UART1, &COMx_InitStructure);     //ʼ1 UART1,UART2,UART3,UART4
    NVIC_UART1_Init(ENABLE,Priority_1);        //жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3

    NVIC_QSPI_Init(DISABLE,Priority_0);     //жʹ, QSPI_SMIE/QSPI_FTIE/QSPI_TCIE/QSPI_TEIE/DISABLE; ȼ(͵) Priority_0~Priority_3
    QSPI_InitStructure.FIFOLevel  = 31;     //FIFOֵ, 0~31
    QSPI_InitStructure.ClockDiv   = 3;      //QSPIʱ = ϵͳʱ/(n+1), 0~255
    QSPI_InitStructure.CSHold     = 1;      //CSʱΪ(n+1)QSPIʱ, 0~7
    QSPI_InitStructure.CKMode     = 1;      //ÿʱCLKƽ, 0/1
    QSPI_InitStructure.FlashSize  = 25;     //FlashСΪ2^(25+1)=64Mֽ, 0~31
    QSPI_InitStructure.SIOO       = DISABLE;//һָģʽ, ENABLE(һָ)/DISABLE(ÿָ)
    QSPI_InitStructure.QSPI_EN    = ENABLE; //QSPIʹ, ENABLE/DISABLE
    //QSPI_Inilize(&QSPI_InitStructure);      //ʼ
		QSPI_Init();
		
    printf("QSPI Test !\n");
		
		ba[0] =  0x01;
		bb[0] =  0x02;
		bc[0] =  0x03;
		W25Q_Enable_QE();
		    W25Q_FastRead_6B(0, (BYTE *)&Fat, 256);     //FLASHһҳȡFAT
				
				DMA_UART_init();
}

void SPI_Read_Nbytes(u32 addr, u16 len) //ʾһ֡ͼƬ
{
		u16 temp;
	
	
    while (QSPI_CheckBusy());           //æ״̬
    QSPI_SetReadMode();                 //ģʽ
    QSPI_SetDataLength(len-1);          //ݳ
    QSPI_SetAddressSize(2);             //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(8);             //DUMMYʱ
    QSPI_NoInstruction();               //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();                   //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();                 //޼ֽ
    QSPI_DataQuadMode();                //Ϊģʽ
    QSPI_SetInstruction(0x6B);          //ָ
    QSPI_InstructionSingMode();         //ָΪģʽ
    QSPI_NoAddress();                   //޵ַģʽ(ֹ󴥷)
    QSPI_SetAddress(addr);              //õַ
    QSPI_AddressSingMode();             //õַΪģʽ
		

		fLoading = 1;
		NVIC_UART1_Init(DISABLE,Priority_1);
    DMA_P2P_CR1 = 0x81;                 //P2P_SRC_QSPIRX(0x80) | u1 tx;
		
    //DMA_QSPI_CFG = 0x20;                //ʹDMAȡ,ж
		DMA_QSPI_CFG = 0xa0;                //ʹDMAȡ,ж
    //DMA_QSPI_STA = 0x00;                //DMA״̬
    DMA_QSPI_AMT = (len-1);             //DMAݳ
    DMA_QSPI_AMTH = (len-1) >> 8;
		DMA_QSPI_RXAH = (WORD)bc >> 8;//DMAĴ洢ʼַ
    DMA_QSPI_RXAL = (BYTE)((u16)bc & 0x00FF);     //DMAĴ洢ʼַ
    //DMA_LCM_CR = 0xa0;
		//DMA_UR1T_TRIG();    //UART2͹
		DMA_UR1T_CR = 0x80;
    DMA_QSPI_CR = 0xa1;                 //DMAQSPI 
		//printf("SPI_Read_Nbytes:%d\n",__LINE__);
    //while(DMA_QSPI_STA==0);             //ȴDMA   
    //DMA_QSPI_STA=0;
		while(fLoading);
		delay_ms(200);
		NVIC_UART1_Init(ENABLE,Priority_1);
		
		

}

//========================================================================
// : Sample_QSPI_Flash
// : ûӦó.
// : None.
// : None.
// 汾: V1.0, 2025-02-08
//========================================================================
void Sample_QSPI_Flash(void)
{
	if(!P32)
	{
		if(!Key1_Flag)
		{
			Key1_cnt++;
			if(Key1_cnt > 50)
			{
				Key1_Flag = 1;

				printf("start:%u,%u,%u,\n",ba[0],bb[0],bc[0]);
				SPI_Read_Nbytes(0,DMA_AMT_LEN);
				delay_ms(100);
				SPI_Read_Nbytes(0,DMA_AMT_LEN);
				printf("end:%u,%u,%u,\n",ba[0],bb[0],bc[0]);
//                W25Q_Erase4K_20(0, TRUE);
//                
//                printf("W25Q_ReadData_03            ");
//                INIT_BUF();
//                W25Q_ReadData_03(0, buf, SIZE);
//                PRINT_BUF();

//                printf("W25Q_PageProgram_02\n");
//                SET_BUF();
//                W25Q_PageProgram_02(0, buf, SIZE);
//                
//                printf("W25Q_ReadData_03            ");
//                INIT_BUF();
//                W25Q_ReadData_03(0, buf, SIZE);
//                PRINT_BUF();
//                
//                printf("W25Q_FastRead_0B            ");
//                INIT_BUF();
//                W25Q_FastRead_0B(0, buf, SIZE);
//                PRINT_BUF();
//                
//                printf("W25Q_FastRead_3B            ");
//                INIT_BUF();
//                W25Q_FastRead_3B(0, buf, SIZE);
//                PRINT_BUF();
//                
//                printf("W25Q_FastRead_6B            ");
//                INIT_BUF();
//                W25Q_FastRead_6B(0, buf, SIZE);
//                PRINT_BUF();
			}
		}
	}
	else
	{
		Key1_cnt = 0;
		Key1_Flag = 0;
	}
}

