/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#ifndef __AI8051U_NVIC_H
#define __AI8051U_NVIC_H

#include "Ai8051U.h"

//========================================================================
//                              
//========================================================================

#define     FALLING_EDGE        1    //½ж
#define     RISING_EDGE         2    //ж

//========================================================================
//                              ʱж
//========================================================================

#define     Timer0_Interrupt(n)      (n==0?(ET0 = 0):(ET0 = 1))        /* Timer0жʹ */
#define     Timer1_Interrupt(n)      (n==0?(ET1 = 0):(ET1 = 1))        /* Timer1жʹ */
#define     Timer2_Interrupt(n)      (n==0?(IE2 &= ~ET2):(IE2 |= ET2))        /* Timer2жʹ */
#define     Timer3_Interrupt(n)      (n==0?(IE2 &= ~ET3):(IE2 |= ET3))        /* Timer3жʹ */
#define     Timer4_Interrupt(n)      (n==0?(IE2 &= ~ET4):(IE2 |= ET4))        /* Timer4жʹ */
#define     Timer11_Interrupt(n)     (n==0?(T11CR &= ~0x02):(T11CR |= 0x02))/* Timer11жʹ */

//========================================================================
//                             ⲿж
//========================================================================

#define     INT0_Interrupt(n)        (n==0?(EX0 = 0):(EX0 = 1))        /* INT0жʹ */
#define     INT1_Interrupt(n)        (n==0?(EX1 = 0):(EX1 = 1))        /* INT1жʹ */
#define     INT2_Interrupt(n)        (n==0?(INTCLKO &= ~EX2):(INTCLKO |= EX2))        /* INT2жʹ */
#define     INT3_Interrupt(n)        (n==0?(INTCLKO &= ~EX3):(INTCLKO |= EX3))        /* INT3жʹ */
#define     INT4_Interrupt(n)        (n==0?(INTCLKO &= ~EX4):(INTCLKO |= EX4))        /* INT4жʹ */

//========================================================================
//                              ADCж
//========================================================================

#define     ADC_Interrupt(n)         (n==0?(EADC = 0):(EADC = 1))      /* ADCжϿ */

//========================================================================
//                              SPIж
//========================================================================

#define     SPI_Interrupt(n)         (n==0?(IE2 &= ~ESPI):(IE2 |= ESPI))      /* SPIжʹ */

//========================================================================
//                              RTCж
//========================================================================

#define     RTC_Interrupt(n)         RTCIEN = (n)        /* RTCжʹ */

//========================================================================
//                              UARTж
//========================================================================

#define     UART1_Interrupt(n)      (n==0?(ES = 0):(ES = 1))       /* UART1жʹ */
#define     UART2_Interrupt(n)      (n==0?(IE2 &= ~ES2):(IE2 |= ES2))     /* UART2жʹ */
#define     UART3_Interrupt(n)      (n==0?(IE2 &= ~ES3):(IE2 |= ES3))     /* UART3жʹ */
#define     UART4_Interrupt(n)      (n==0?(IE2 &= ~ES4):(IE2 |= ES4))     /* UART4жʹ */

//========================================================================
//                              I2Cж
//========================================================================

#define     I2C_Master_Inturrupt(n) (n==0?(I2CMSCR &= ~0x80):(I2CMSCR |= 0x80))    //0ֹ I2C ܣ1ʹ I2C 

//========================================================================
//                              QSPIж
//========================================================================

#define     QSPI_Interrupt(n)       QSPI_CR3 = (n & 0x0f)          /* QSPIжʹ */

//========================================================================
//                            жȼ
//========================================================================

//2жȼ
#define     UART2_Priority(n)           do{if(n == 0) (IP2H &= ~PS2H), IP2 &= ~PS2; \
                                            if(n == 1) (IP2H &= ~PS2H), IP2 |= PS2; \
                                            if(n == 2) (IP2H |= PS2H), IP2 &= ~PS2; \
                                            if(n == 3) (IP2H |= PS2H), IP2 |= PS2; \
                                        }while(0)
//SPIжȼ
#define     SPI_Priority(n)             do{if(n == 0) (IP2H &= ~PSPIH), IP2 &= ~PSPI; \
                                            if(n == 1) (IP2H &= ~PSPIH), IP2 |= PSPI; \
                                            if(n == 2) (IP2H |= PSPIH), IP2 &= ~PSPI; \
                                            if(n == 3) (IP2H |= PSPIH), IP2 |= PSPI; \
                                        }while(0)
//ⲿж4жȼ
#define     INT4_Priority(n)            do{if(n == 0) (IP2H &= ~PX4H), IP2 &= ~PX4; \
                                            if(n == 1) (IP2H &= ~PX4H), IP2 |= PX4; \
                                            if(n == 2) (IP2H |= PX4H), IP2 &= ~PX4; \
                                            if(n == 3) (IP2H |= PX4H), IP2 |= PX4; \
                                        }while(0)
//Ƚжȼ
#define     CMP_Priority(n)             do{if(n == 0) (IP2H &= ~PCMPH), IP2 &= ~PCMP; \
                                            if(n == 1) (IP2H &= ~PCMPH), IP2 |= PCMP; \
                                            if(n == 2) (IP2H |= PCMPH), IP2 &= ~PCMP; \
                                            if(n == 3) (IP2H |= PCMPH), IP2 |= PCMP; \
                                        }while(0)
//I2Cжȼ
#define     I2C_Priority(n)             do{if(n == 0) (IP2H &= ~PI2CH), IP2 &= ~PI2C; \
                                            if(n == 1) (IP2H &= ~PI2CH), IP2 |= PI2C; \
                                            if(n == 2) (IP2H |= PI2CH), IP2 &= ~PI2C; \
                                            if(n == 3) (IP2H |= PI2CH), IP2 |= PI2C; \
                                        }while(0)
//3жȼ
#define     UART3_Priority(n)           do{if(n == 0) (IP3H &= ~PS3H), IP3 &= ~PS3; \
                                            if(n == 1) (IP3H &= ~PS3H), IP3 |= PS3; \
                                            if(n == 2) (IP3H |= PS3H), IP3 &= ~PS3; \
                                            if(n == 3) (IP3H |= PS3H), IP3 |= PS3; \
                                        }while(0)
//4жȼ
#define     UART4_Priority(n)           do{if(n == 0) (IP3H &= ~PS4H), IP3 &= ~PS4; \
                                            if(n == 1) (IP3H &= ~PS4H), IP3 |= PS4; \
                                            if(n == 2) (IP3H |= PS4H), IP3 &= ~PS4; \
                                            if(n == 3) (IP3H |= PS4H), IP3 |= PS4; \
                                        }while(0)

//ⲿж0жȼ
#define     INT0_Priority(n)            do{if(n == 0) (IPH &= ~PX0H), PX0 = 0; \
                                            if(n == 1) (IPH &= ~PX0H), PX0 = 1; \
                                            if(n == 2) (IPH |= PX0H), PX0 = 0; \
                                            if(n == 3) (IPH |= PX0H), PX0 = 1; \
                                        }while(0)
//ⲿж1жȼ
#define     INT1_Priority(n)            do{if(n == 0) (IPH &= ~PX1H), PX1 = 0; \
                                            if(n == 1) (IPH &= ~PX1H), PX1 = 1; \
                                            if(n == 2) (IPH |= PX1H), PX1 = 0; \
                                            if(n == 3) (IPH |= PX1H), PX1 = 1; \
                                        }while(0)
//ʱ0жȼ
#define     Timer0_Priority(n)          do{if(n == 0) (IPH &= ~PT0H), PT0 = 0; \
                                            if(n == 1) (IPH &= ~PT0H), PT0 = 1; \
                                            if(n == 2) (IPH |= PT0H), PT0 = 0; \
                                            if(n == 3) (IPH |= PT0H), PT0 = 1; \
                                        }while(0)
//ʱ1жȼ
#define     Timer1_Priority(n)          do{if(n == 0) (IPH &= ~PT1H), PT1 = 0; \
                                            if(n == 1) (IPH &= ~PT1H), PT1 = 1; \
                                            if(n == 2) (IPH |= PT1H), PT1 = 0; \
                                            if(n == 3) (IPH |= PT1H), PT1 = 1; \
                                        }while(0)
//1жȼ
#define     UART1_Priority(n)           do{if(n == 0) (IPH &= ~PSH), PS = 0; \
                                            if(n == 1) (IPH &= ~PSH), PS = 1; \
                                            if(n == 2) (IPH |= PSH), PS = 0; \
                                            if(n == 3) (IPH |= PSH), PS = 1; \
                                        }while(0)
//ADCжȼ
#define     ADC_Priority(n)             do{if(n == 0) (IPH &= ~PADCH), PADC = 0; \
                                            if(n == 1) (IPH &= ~PADCH), PADC = 1; \
                                            if(n == 2) (IPH |= PADCH), PADC = 0; \
                                            if(n == 3) (IPH |= PADCH), PADC = 1; \
                                        }while(0)
//ѹжȼ
#define     LVD_Priority(n)             do{if(n == 0) (IPH &= ~PLVDH), PADC = 0; \
                                            if(n == 1) (IPH &= ~PLVDH), PADC = 1; \
                                            if(n == 2) (IPH |= PLVDH), PADC = 0; \
                                            if(n == 3) (IPH |= PLVDH), PADC = 1; \
                                        }while(0)
//߼PWMAжȼ
#define     PWMA_Priority(n)            do{if(n == 0) (IP2H &= ~PPWMAH), IP2 &= ~PPWMA; \
                                            if(n == 1) (IP2H &= ~PPWMAH), IP2 |= PPWMA; \
                                            if(n == 2) (IP2H |= PPWMAH), IP2 &= ~PPWMA; \
                                            if(n == 3) (IP2H |= PPWMAH), IP2 |= PPWMA; \
                                        }while(0)

//߼PWMBжȼ
#define     PWMB_Priority(n)            do{if(n == 0) (IP2H &= ~PPWMBH), IP2 &= ~PPWMB; \
                                            if(n == 1) (IP2H &= ~PPWMBH), IP2 |= PPWMB; \
                                            if(n == 2) (IP2H |= PPWMBH), IP2 &= ~PPWMB; \
                                            if(n == 3) (IP2H |= PPWMBH), IP2 |= PPWMB; \
                                        }while(0)

//RTCжȼ
#define     RTC_Priority(n)             do{if(n == 0) (IP3H &= ~PRTCH), IP3 &= ~PRTC; \
                                            if(n == 1) (IP3H &= ~PRTCH), IP3 |= PRTC; \
                                            if(n == 2) (IP3H |= PRTCH), IP3 &= ~PRTC; \
                                            if(n == 3) (IP3H |= PRTCH), IP3 |= PRTC; \
                                        }while(0)

//QSPIжȼ
#define     QSPI_Priority(n)            do{if(n == 0) QSPI_DCR1 &= ~0x0c; \
                                            if(n == 1) QSPI_DCR1 = (QSPI_DCR1 & ~0x0c) | 0x04; \
                                            if(n == 2) QSPI_DCR1 = (QSPI_DCR1 & ~0x0c) | 0x08; \
                                            if(n == 3) QSPI_DCR1 |= 0x0c; \
                                        }while(0)

//========================================================================
//                           ⲿͱ
//========================================================================

u8 NVIC_Timer0_Init(u8 State, u8 Priority);
u8 NVIC_Timer1_Init(u8 State, u8 Priority);
u8 NVIC_Timer2_Init(u8 State, u8 Priority);
u8 NVIC_Timer3_Init(u8 State, u8 Priority);
u8 NVIC_Timer4_Init(u8 State, u8 Priority);
u8 NVIC_Timer11_Init(u8 State, u8 Priority);
u8 NVIC_INT0_Init(u8 State, u8 Priority);
u8 NVIC_INT1_Init(u8 State, u8 Priority);
u8 NVIC_INT2_Init(u8 State, u8 Priority);
u8 NVIC_INT3_Init(u8 State, u8 Priority);
u8 NVIC_INT4_Init(u8 State, u8 Priority);
u8 NVIC_ADC_Init(u8 State, u8 Priority);
u8 NVIC_SPI_Init(u8 State, u8 Priority);
u8 NVIC_RTC_Init(u8 State, u8 Priority);
u8 NVIC_CMP_Init(u8 State, u8 Priority);
u8 NVIC_I2C_Init(u8 Mode, u8 State, u8 Priority);
u8 NVIC_UART1_Init(u8 State, u8 Priority);
u8 NVIC_UART2_Init(u8 State, u8 Priority);
u8 NVIC_UART3_Init(u8 State, u8 Priority);
u8 NVIC_UART4_Init(u8 State, u8 Priority);
u8 NVIC_PWM_Init(u8 Channel, u8 State, u8 Priority);
u8 NVIC_DMA_ADC_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_M2M_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_SPI_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_LCM_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_I2CT_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_I2CR_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART1_Tx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART1_Rx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART2_Tx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART2_Rx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART3_Tx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART3_Rx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART4_Tx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_DMA_UART4_Rx_Init(u8 State, u8 Priority, u8 Bus_Priority);
u8 NVIC_LCM_Init(u8 State, u8 Priority);
u8 NVIC_QSPI_Init(u8 State, u8 Priority);

#endif
