/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#ifndef    __AI8051U_SPI_H
#define    __AI8051U_SPI_H

#include "Ai8051U.h"

//========================================================================
//                               SPI
//========================================================================

#define SPI_SSIG_Set(n)         do{ if(n == 1) SPCTL |= SSIG; if(n == 0) SPCTL &= ~SSIG; }while(0)        /* SSŹܿ */
#define SPI_Start(n)            do{ if(n == 1) SPCTL |= SPEN; if(n == 0) SPCTL &= ~SPEN; }while(0)        /* SPIʹܿλ */
#define SPI_FirstBit_Set(n)     do{ if(n == 1) SPCTL |= DORD; if(n == 0) SPCTL &= ~DORD; }while(0)        /* ݷ/˳ MSB/LSB */
#define SPI_Mode_Set(n)         do{ if(n == 1) SPCTL |= MSTR; if(n == 0) SPCTL &= ~MSTR; }while(0)        /* SPIģʽ */
#define SPI_CPOL_Set(n)         do{ if(n == 1) SPCTL |= CPOL; if(n == 0) SPCTL &= ~CPOL; }while(0)        /* SPIʱӼԿ */
#define SPI_CPHA_Set(n)         do{ if(n == 1) SPCTL |= CPHA; if(n == 0) SPCTL &= ~CPHA; }while(0)        /* SPIʱλ */
#define SPI_Clock_Select(n)     SPCTL = (SPCTL & ~0x03) | (n)    /* SPIʱƵѡ */

#define SPI_ClearFlag()         {SPSTAT |= SPIF; SPSTAT |= WCOL;}    /* д 1  SPIFWCOL ־ */

#define HSSPI_Enable(n)         HSSPI_CFG2 |= 0x20       //ʹSPIģʽ
#define HSSPI_Disable(n)        HSSPI_CFG2 &= ~0x20      //رSPIģʽ

//========================================================================
//                              
//========================================================================

#define SPI_BUF_LENTH   128
#define SPI_BUF_type    edata

//sbit  SPI_SS      = P1^4;
SBIT(SPI_SS,0x90/*P1*/,4);
//sbit  SPI_MOSI    = P1^5;
SBIT(SPI_MOSI,0x90/*P1*/,5);
//sbit  SPI_MISO    = P1^6;
SBIT(SPI_MISO,0x90/*P1*/,6);
//sbit  SPI_SCLK    = P1^7;
SBIT(SPI_SCLK,0x90/*P1*/,7);

//sbit  SPI_SS_2    = P2^4;
SBIT(SPI_SS_2,0xa0/*P2*/,4);
//sbit  SPI_MOSI_2  = P2^5;
SBIT(SPI_MOSI_2,0xa0/*P2*/,5);
//sbit  SPI_MISO_2  = P2^6;
SBIT(SPI_MISO_2,0xa0/*P2*/,6);
//sbit  SPI_SCLK_2  = P2^7;
SBIT(SPI_SCLK_2,0xa0/*P2*/,7);

//sbit  SPI_SS_3    = P4^0;
SBIT(SPI_SS_3,0xc0/*P4*/,0);
//sbit  SPI_MOSI_3  = P4^1;
SBIT(SPI_MOSI_3,0xc0/*P4*/,1);
//sbit  SPI_MISO_3  = P4^2;
SBIT(SPI_MISO_3,0xc0/*P4*/,2);
//sbit  SPI_SCLK_3  = P4^3;
SBIT(SPI_SCLK_3,0xc0/*P4*/,3);

//sbit  SPI_SS_4    = P3^5;
SBIT(SPI_SS_4,0xb0/*P3*/,5);
//sbit  SPI_MOSI_4  = P3^4;
SBIT(SPI_MOSI_4,0xb0/*P3*/,4);
//sbit  SPI_MISO_4  = P3^3;
SBIT(SPI_MISO_4,0xb0/*P3*/,3);
//sbit  SPI_SCLK_4  = P3^2;
SBIT(SPI_SCLK_4,0xb0/*P3*/,2);

#define SPI_Mode_Slave      0
#define SPI_Mode_Master     1
#define SPI_CPOL_Low        0
#define SPI_CPOL_High       1
#define SPI_CPHA_1Edge      0
#define SPI_CPHA_2Edge      1
#define SPI_Speed_4         0
#define SPI_Speed_8         1
#define SPI_Speed_16        2
#define SPI_Speed_2         3
#define SPI_MSB             0
#define SPI_LSB             1

typedef struct
{
    u8    SPI_Enable;     //SPI, ENABLE,DISABLE
    u8    SPI_SSIG;       //Ƭѡλ, ENABLE(SSŹ), DISABLE(SSȷӻ)
    u8    SPI_FirstBit;   //SPI_MSB, SPI_LSB
    u8    SPI_Mode;       //SPI_Mode_Master, SPI_Mode_Slave
    u8    SPI_CPOL;       //SPI_CPOL_High,   SPI_CPOL_Low
    u8    SPI_CPHA;       //SPI_CPHA_1Edge,  SPI_CPHA_2Edge
    u8    SPI_Speed;      //SPI_Speed_4, SPI_Speed_8, SPI_Speed_16, SPI_Speed_2
} SPI_InitTypeDef;


extern bit B_SPI_Busy;  //æ־
extern u8  SPI_RxCnt;
extern u8  SPI_RxTimerOut;
extern u8  SPI_BUF_type SPI_RxBuffer[SPI_BUF_LENTH];

void SPI_Init(SPI_InitTypeDef *SPIx);
void SPI_SetMode(u8 mode);
void SPI_WriteByte(u8 dat);
u8 SPI_ReadByte(void);

#endif

