/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#ifndef __AI8051U_TIMER_H
#define __AI8051U_TIMER_H

#include "Ai8051U.h"

//========================================================================
//                             ʱ0
//========================================================================

/* 0,1: ʱ0ʱ, 12T/1T; 2: ʱ0    */
#define Timer0_Mode_Select(n)   do{if(n == 0) (AUXR &= ~T0x12), TMOD &= ~T0_CT; \
                                   if(n == 1) (AUXR |= T0x12), TMOD &= ~T0_CT; \
                                   if(n == 2) TMOD |= T0_CT; \
                                }while(0)

#define Timer0_CLK_Output(n)    do{ if(n == 1) INTCLKO |= T0CLKO; if(n == 0) INTCLKO &= ~T0CLKO; }while(0)                  /* T0 T0ʹ */
#define Timer0_Run(n)           (n==0?(TR0 = 0):(TR0 = 1))  /* ʱ0ʹ */
#define Timer0_Stop()           TR0 = 0                     /* ֹʱ0 */
#define T0_Load(n)              TH0 = (n) / 256, TL0 = (n) % 256

//========================================================================
//                             ʱ1
//========================================================================

/* 0,1: ʱ1ʱ, 12T/1T; 2: ʱ1    */
#define Timer1_Mode_Select(n)   do{if(n == 0) (AUXR &= ~T1x12), TMOD &= ~T1_CT; \
                                   if(n == 1) (AUXR |= T1x12), TMOD &= ~T1_CT; \
                                   if(n == 2) TMOD |= T1_CT; \
                                }while(0)

#define Timer1_CLK_Output(n)    do{ if(n == 1) INTCLKO |= T1CLKO; if(n == 0) INTCLKO &= ~T1CLKO; }while(0)                  /* T1 T1ʹ */
#define Timer1_Run(n)           (n==0?(TR1 = 0):(TR1 = 1))  /* ʱ1ʹ */
#define Timer1_Stop()           TR1 = 0                     /* ֹʱ1 */
#define T1_Load(n)              TH1 = (n) / 256, TL1 = (n) % 256

//========================================================================
//                             ʱ2
//========================================================================

/* 0,1: ʱ2ʱ, 12T/1T; 2: ʱ2    */
#define Timer2_Mode_Select(n)   do{if(n == 0) (AUXR &= ~T2x12), AUXR &= ~T2_CT; \
                                   if(n == 1) (AUXR |= T2x12), AUXR &= ~T2_CT; \
                                   if(n == 2) AUXR |= T2_CT; \
                                }while(0)

#define Timer2_CLK_Output(n)    do{ if(n == 1) INTCLKO |= T2CLKO; if(n == 0) INTCLKO &= ~T2CLKO; }while(0)                  /* T2 T2ʹ */
#define Timer2_Run(n)           (n==0?(AUXR &= ~T2R):(AUXR |= T2R))  /* ʱ2ʹ */
#define Timer2_Stop()           (AUXR &= ~T2R)                     /* ֹʱ2 */
#define T2_Load(n)              T2H = (n) / 256, T2L = (n) % 256

//========================================================================
//                             ʱ3
//========================================================================

/* 0,1: ʱ3ʱ, 12T/1T; 2: ʱ3    */
#define Timer3_Mode_Select(n)   do{if(n == 0) (T4T3M &= ~T3x12), T4T3M &= ~T3_CT; \
                                   if(n == 1) (T4T3M |= T3x12), T4T3M &= ~T3_CT; \
                                   if(n == 2) T4T3M |= T3_CT; \
                                }while(0)

#define Timer3_CLK_Output(n)    do{ if(n == 1) T4T3M |= T3CLKO; if(n == 0) T4T3M &= ~T3CLKO; }while(0)                  /* T3 T3ʹ */
#define Timer3_Run(n)           (n==0?(T4T3M &= ~T3R):(T4T3M |= T3R))  /* ʱ3ʹ */
#define Timer3_Stop()           (T4T3M &= ~T3R)                     /* ֹʱ3 */
#define T3_Load(n)              T3H = (n) / 256, T3L = (n) % 256

//========================================================================
//                             ʱ4
//========================================================================

/* 0,1: ʱ4ʱ, 12T/1T; 2: ʱ4    */
#define Timer4_Mode_Select(n)   do{if(n == 0) (T4T3M &= ~T4x12), T4T3M &= ~T4_CT; \
                                   if(n == 1) (T4T3M |= T4x12), T4T3M &= ~T4_CT; \
                                   if(n == 2) T4T3M |= T4_CT; \
                                }while(0)

#define Timer4_CLK_Output(n)    do{ if(n == 1) T4T3M |= T4CLKO; if(n == 0) T4T3M &= ~T4CLKO; }while(0)                  /* T4 T4ʹ */
#define Timer4_Run(n)           (n==0?(T4T3M &= ~T4R):(T4T3M |= T4R))  /* ʱ4ʹ */
#define Timer4_Stop()           (T4T3M &= ~T4R)                     /* ֹʱ4 */
#define T4_Load(n)              T4H = (n) / 256,    T4L = (n) % 256

//========================================================================
//                             ʱ11
//========================================================================

/* 0,1: ʱ11ʱ, 12T/1T; 2: ʱ11    */
#define Timer11_Mode_Select(n)  do{if(n == 0) T11CR &= ~0x50; \
                                   if(n == 1) T11CR |= 0x10, T11CR &= ~0x40; \
                                   if(n == 2) T11CR |= 0x50; \
                                }while(0)

#define Timer11_CLK_Select(n)   do{if(n == 0) T11CR &= ~0x0c; \
                                   if(n == 1) T11CR |= 0x04, T11CR &= ~0x08; \
                                   if(n == 2) T11CR |= 0x08, T11CR &= ~0x04; \
                                   if(n == 3) T11CR |= 0x0c; \
                                }while(0)

#define Timer11_CLK_Output(n)   (n==0?(T11CR &= ~0x20):(T11CR |= 0x20)) /* T11 T11ʹ */
#define Timer11_Run(n)          (n==0?(T11CR &= ~0x80):(T11CR |= 0x80)) /* ʱ1ʹ */
#define Timer11_Stop()          T11CR &= ~0x80                          /* ֹʱ4 */
#define T11_Load(n)             T11H = (n) / 256, T11L = (n) % 256

//========================================================================
//                              
//========================================================================

#define Timer0                        0
#define Timer1                        1
#define Timer2                        2
#define Timer3                        3
#define Timer4                        4
#define Timer11                       11

#define TIM_16BitAutoReload           0
#define TIM_16Bit                     1
#define TIM_8BitAutoReload            2
#define TIM_16BitAutoReloadNoMask     3
#define TIM_T1Stop                    3

#define TIM_CLOCK_12T                 0
#define TIM_CLOCK_1T                  1
#define TIM_CLOCK_Ext                 2

#define TIM_SOURCE_SYSCLK             0
#define TIM_SOURCE_HIRC               1
#define TIM_SOURCE_X32K               2
#define TIM_SOURCE_LIRC               3

typedef struct
{
    u8    TIM_Mode;       //ģʽ,      TIM_16BitAutoReload,TIM_16Bit,TIM_8BitAutoReload,TIM_16BitAutoReloadNoMask
    u8    TIM_ClkMode;    //ģʽѡ       TIM_CLOCK_1T,TIM_CLOCK_12T,TIM_CLOCK_Ext
    u8    TIM_ClkSource;  //ʱԴ         TIM_SOURCE_SYSCLK,TIM_SOURCE_HIRC,TIM_SOURCE_X32K,TIM_SOURCE_LIRC
    u8    TIM_ClkOut;     //ʱʱ, ENABLE,DISABLE
    u16   TIM_Value;      //װسֵ
    u8    TIM_PS;         //8λԤƵ
    u8    TIM_Run;        //Ƿ        ENABLE,DISABLE
} TIM_InitTypeDef;

u8 Timer_Inilize(u8 TIM, TIM_InitTypeDef *TIMx);

#endif
