/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#ifndef __AI8051U_UART_H
#define __AI8051U_UART_H     

#include "Ai8051U.h"

//========================================================================
//                              
//========================================================================

#define UART1    1       //ʹЩھͿӦĶ壬õĴڿε壬ʡԴ
#define UART2    2
#define UART3    3
#define UART4    4

#define UART_BUF_type    xdata  //ôշݻռ䣬ѡ edata  xdata

#define UART_QUEUE_MODE    0    //ôڷģʽ0ģʽ1ģʽ

#define PRINTF_SELECT  UART1    //ѡ printf ʹõĴڣ UART1~UART4

#ifdef UART1
#define COM_TX1_Lenth    128    //ô1ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#define COM_RX1_Lenth    128    //ô1ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#endif
#ifdef UART2
#define COM_TX2_Lenth    128    //ô2ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#define COM_RX2_Lenth    128    //ô2ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#endif
#ifdef UART3
#define COM_TX3_Lenth    64     //ô3ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#define COM_RX3_Lenth    64     //ô3ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#endif
#ifdef UART4
#define COM_TX4_Lenth    64     //ô4ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#define COM_RX4_Lenth    64     //ô4ݻСȶ256ҪóȱȽϵıu8Ϊu16/u32.
#endif

#define UART_ShiftRight    0        //ͬλ
#define UART_8bit_BRTx    (1<<6)    //8λ,ɱ䲨
#define UART_9bit         (2<<6)    //9λ,̶
#define UART_9bit_BRTx    (3<<6)    //9λ,ɱ䲨


#define BRT_Timer1         1         //ʷѡ
#define BRT_Timer2         2
#define BRT_Timer3         3
#define BRT_Timer4         4

#define PARITY_NONE        0         //У
#define PARITY_EVEN        4         //żУ
#define PARITY_ODD         6         //У

#define TO_SCALE_BRT       0         //ʱʱԴλ()
#define TO_SCALE_SYSCLK    1         //ʱʱԴϵͳʱ

//========================================================================
//                              UART
//========================================================================

#define UART1_RxEnable(n)        (n==0?(REN = 0):(REN = 1))            /* UART1ʹ */
#define UART2_RxEnable(n)        (n==0?(S2CON &= ~S2REN):(S2CON |= S2REN))        /* UART2ʹ */
#define UART3_RxEnable(n)        (n==0?(S3CON &= ~S3REN):(S3CON |= S3REN))        /* UART3ʹ */
#define UART4_RxEnable(n)        (n==0?(S4CON &= ~S4REN):(S4CON |= S4REN))        /* UART4ʹ */


#define CLR_TI()             TI = 0         /* TI  */
#define CLR_RI()             RI = 0         /* RI  */
#define CLR_TI2()            (S2CON &= ~S2TI)       /* TI2 */
#define CLR_RI2()            (S2CON &= ~S2RI)       /* RI2 */
#define CLR_TI3()            (S3CON &= ~S3TI)       /* TI3 */
#define CLR_RI3()            (S3CON &= ~S3RI)       /* RI3 */
#define CLR_TI4()            (S4CON &= ~S4TI)       /* TI3 */
#define CLR_RI4()            (S4CON &= ~S4RI)       /* RI3 */

#define S3_8bit()            (S3CON &= ~S3SM0)      /* 3ģʽ08λUART = ʱ / 4 */
#define S3_9bit()            (S3CON |= S3SM0)      /* 3ģʽ19λUART = ʱ / 4 */
#define S3_BRT_UseTimer3()   (S3CON |= S3ST3)      /* BRT select Timer3 */
#define S3_BRT_UseTimer2()   (S3CON &= ~S3ST3)      /* BRT select Timer2 */

#define S4_8bit()            (S4CON &= ~S4SM0)      /* 4ģʽ08λUART = ʱ / 4 */
#define S4_9bit()            (S4CON |= S4SM0)      /* 4ģʽ19λUART = ʱ / 4 */
#define S4_BRT_UseTimer4()   (S4CON |= S4ST4)      /* BRT select Timer4 */
#define S4_BRT_UseTimer2()   (S4CON &= ~S4ST4)      /* BRT select Timer2 */

#define S1_CLR_TOIF()        UR1TOSR |= 0x80    /* 1жϳʱ־λTOIF */
#define S2_CLR_TOIF()        UR2TOSR |= 0x80    /* 2жϳʱ־λTOIF */
#define S3_CLR_TOIF()        UR3TOSR |= 0x80    /* 3жϳʱ־λTOIF */
#define S4_CLR_TOIF()        UR4TOSR |= 0x80    /* 4жϳʱ־λTOIF */

//========================================================================
//                              
//========================================================================
extern u8    B_TX1_busy;
typedef struct
{ 
    u8    TX_send;      //ѷָ
    u8    TX_write;     //дָ
    volatile u8    B_TX_busy;    //æ־

    u8    RX_Cnt;       //ֽڼ
    u8    RX_TimeOut;   //ճʱ
} COMx_Define; 

typedef struct
{ 
    u8    UART_Mode;        //ģʽ,        UART_ShiftRight,UART_8bit_BRTx,UART_9bit,UART_9bit_BRTx
    u8    UART_BRT_Use;     //ʹò,  BRT_Timer1,BRT_Timer2,BRT_Timer3,BRT_Timer4
    u32   UART_BaudRate;    //,      һ 110 ~ 115200
    u8    UART_RxEnable;    //,   ENABLE,DISABLE
    u8    BaudRateDouble;   //ʼӱ, ENABLE,DISABLE
    u8    ParityMode;       //Уģʽ,   PARITY_NONE,PARITY_EVEN,PARITY_ODD

    u8    TimeOutEnable;    //ճʱʹ, ENABLE,DISABLE
    u8    TimeOutINTEnable; //ʱжʹ, ENABLE,DISABLE
    u8    TimeOutScale;     //ʱʱԴѡ, TO_SCALE_BRT,TO_SCALE_SYSCLK
    u32   TimeOutTimer;     //ʱʱ, 1 ~ 0xffffff
} COMx_InitDefine; 

#ifdef UART1
extern COMx_Define    COM1;
extern u8 UART_BUF_type TX1_Buffer[COM_TX1_Lenth];    //ͻ
extern u8 UART_BUF_type RX1_Buffer[COM_RX1_Lenth];    //ջ
#endif
#ifdef UART2
extern COMx_Define    COM2;
extern u8 UART_BUF_type TX2_Buffer[COM_TX2_Lenth];    //ͻ
extern u8 UART_BUF_type RX2_Buffer[COM_RX2_Lenth];    //ջ
#endif
#ifdef UART3
extern COMx_Define    COM3;
extern u8 UART_BUF_type TX3_Buffer[COM_TX3_Lenth];    //ͻ
extern u8 UART_BUF_type RX3_Buffer[COM_RX3_Lenth];    //ջ
#endif
#ifdef UART4
extern COMx_Define    COM4;
extern u8 UART_BUF_type TX4_Buffer[COM_TX4_Lenth];    //ͻ
extern u8 UART_BUF_type RX4_Buffer[COM_RX4_Lenth];    //ջ
#endif

u8 UART_Configuration(u8 UARTx, COMx_InitDefine *COMx);
#ifdef UART1
void TX1_write2buff(u8 dat);    //1ͺ
void PrintString1(u8 *puts);
#endif
#ifdef UART2
void TX2_write2buff(u8 dat);    //2ͺ
void PrintString2(u8 *puts);
#endif
#ifdef UART3
void TX3_write2buff(u8 dat);    //3ͺ
void PrintString3(u8 *puts);
#endif
#ifdef UART4
void TX4_write2buff(u8 dat);    //4ͺ
void PrintString4(u8 *puts);
#endif

//void COMx_write2buff(u8 UARTx, u8 dat);    //ڷͺ
//void PrintString(u8 UARTx, u8 *puts);

#endif

